import josx.platform.rcx.*;

public abstract class AbstractApplication implements Constants {

	public static Thread mainThread;

	public static Runtime runtime;

	public AbstractApplication() {

		runtime = Runtime.getRuntime();

		mainThread = Thread.currentThread();

		// play start sound
		Sound.buzz();
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
		}

		// set the motor power to the highest level
		Motor.A.setPower(7);
		Motor.C.setPower(7);

		// initialise S1
		Sensor.S1.setTypeAndMode(1, 0X20);
		Sensor.S1.activate();

		Serial.setRangeLong();

		Button.RUN.addButtonListener(new ButtonListener() {

			public void buttonPressed(Button b) {
			}

			public void buttonReleased(Button b) {
				mainThread.interrupt();
			}

		});

	}

	public static void move(byte dir) {

		if (dir == LEFT) { // left turn			
			
			Motor.A.backward();
			Motor.C.forward();

		} else if (dir == RIGHT) { // right turn
			
			Motor.A.forward();
			Motor.C.backward();
		} else if (dir == FORWARD) { // move forward
			
			Motor.A.forward();
			Motor.C.forward();
		} else if (dir == STOP) {
			stopMoving();
		} else if (dir == SMOOTH_STOP) {
			smoothStop();
		}

	}

	private static void stopMoving() {
		Motor.A.stop();
		Motor.C.stop();
	}

	private static void smoothStop() {
		Motor.A.flt();
		Motor.C.flt();
	}

}
