import josx.platform.rcx.*;

public class FollowLineApplication extends AbstractApplication {

	private static int time = 0;
	
	private static byte lastDir = FORWARD;
	
	public FollowLineApplication() throws InterruptedException {

		super();

		LightSensorListener.init(Sensor.S2);

		/*
		AbstractApplication.move(LEFT);
		while (LightSensorListener.isBlack())
			;

		int t1 = (int) System.currentTimeMillis();
		while (!LightSensorListener.isBlack())
			;
		t1 = (int) System.currentTimeMillis() - t1;

		AbstractApplication.move(RIGHT);
		while (LightSensorListener.isBlack())
			;

		int t2 = (int) System.currentTimeMillis();
		while (!LightSensorListener.isBlack())
			;
		t2 = (int) System.currentTimeMillis() - t2;

		AbstractApplication.move(STOP);

		LineSeek.setFactor(t1, t2);
*/
		LineSeek.setFactor(1,1);
		
		// initialise S2
		new LightSensorListener(Thread.currentThread());

		// start moving forward
		initMove(FORWARD);
		while (!Thread.interrupted())
			;

		move(STOP);

		while (Serial.isSending())
			;

	}

	public static void main(String[] args) throws InterruptedException {
		new FollowLineApplication();
	}

	private void initMove(byte dir) {

		lastDir = dir;
		time = (int) (System.currentTimeMillis());
		AbstractApplication.move(dir);

	}

	public static void move(byte dir) {

		int t = (int) (System.currentTimeMillis());

		short dur = (short)(t - time);
		
		dur = (lastDir == LEFT) ? (short)(dur / LineSeek.getFactor()) : dur;
		MoveHistory.add(lastDir,dur);

		time = t;
		lastDir = dir;

		AbstractApplication.move(dir);

	}

}
