import josx.platform.rcx.*;

public class LightSensorListener implements SensorListener {
	
	public static int blackValue;

	private LineSeek lineSeek;
	
	public static Sensor sensor;
	
	public static void init(Sensor sensor) {
		
		sensor.setTypeAndMode(3,0x80);
		sensor.activate();
		
		LightSensorListener.sensor = sensor;
		
		try {
			Thread.sleep(500);
		} catch (InterruptedException e) {};
		
		blackValue = sensor.readValue();
		
	}

	public LightSensorListener(Thread mainThread) {
		
		lineSeek = new LineSeek(mainThread);
		lineSeek.start();
		
		sensor.addSensorListener(this);
		
	}
	
    public static boolean isBlack() {
		
    	short val = (short)sensor.readValue();
    	
		return (val < blackValue + 5);
		
	}
	
	public static boolean isBlack(int val) {
		
		return (val < blackValue + 5);
		
	}

	public void stateChanged(Sensor source, int oldValue, int newValue) {
		//line has been lost
		if (!lineSeek.isSeeking() && !isBlack(newValue)) {
			lineSeek.startSeeking();
		}
		//line has been found
		if (lineSeek.isSeeking() && isBlack(newValue)) {
			Sound.beep();
			lineSeek.stopSeeking();
		}
	}

}
